
Option Explicit On


NameSpace ghostwin

Friend Class clsIniRW

	Friend enum ZOOMMODE
		ZOOM_NYANPEN
		ZOOM_MSPAINT
	End enum

	Private Shared mstrIniFileName		as String
	Private Shared mstrAllFileData			as String

	Private Const mstrKey_FilePath As String = "FilePath"
	Private Const mstrKey_ImgFormRect As String = "ImageRect"
	Private Const mstrKey_ImgTransparent As String = "ImageTransparent"
	Private Const mstrKey_Opacity As String = "Opacity"
	Private Const mstrKey_Zoom As String = "Zoom"
	Private Const mstrKey_ZoomMode As String = "ZoomMode"



	Public Shared Property IniKey( ByVal strKey As System.String ) As String
	Get
		' Co
		if mstrAllFileData Is Nothing Then
			mstrAllFileData = ""
		End If

		Dim nKeyPos As Integer = _
			mstrAllFileData.IndexOf( strKey & "=" )
		If NKeyPos < 0 Then
			Return ""
		End If

		Dim nKeyPosEnd As Integer = _
			mstrAllFileData.IndexOf( ControlChars.NewLine , _
								 nKeyPos+strKey.Length+1 )

		If nKeyPosEnd <0 Then
			nKeyPosEnd = mstrAllFileData.Length

			Return mstrAllFileData.SubString( nKeyPos + strKey.Length+1 )

		Else
			'01234567890
			'aaaa=aaaaxx
			' 9 -0 - 4 - 1(=)
			Return mstrAllFileData.SubString( nKeyPos + strKey.Length+1, _ 
										  nKeyPosEnd - nKeyPos - strKey.Length-1 )

		End If


	End Get

	Set( ByVal strValue As String )

		' Co

		Dim sr		As System.IO.StringReader
		Dim srout	As System.IO.StringWriter

		if mstrAllFileData Is Nothing Then
			mstrAllFileData = _
				strKey & "=" & strValue
				Return
		End If

		sr    = new System.IO.StringReader( mstrAllFileData )
		srout = new System.IO.StringWriter()
		Dim strLine			As String
		Dim blAdded			As Boolean

		blAdded = false
		strLine = sr.ReadLine()
		Do While strLine IsNot Nothing

			If blAdded = false And strLine.StartsWith( strKey & "=" ) Then
				srout.WriteLine( _ 
						strKey & "=" & strValue )
				blAdded = true
			ElseIf strLine.Length > 0 Then
				srout.WriteLine( strLine )
			End If

			strLine = sr.ReadLine()
		Loop
		If blAdded = false Then
			srout.WriteLine( strKey & "=" & strValue )
		End If

		mstrAllFileData = srout.ToString()
		sr.Close()
		srout.Close()
		sr.Dispose()
		srout.Dispose()
		sr = Nothing
		srout = Nothing

		Return
	End Set
	End Property



	Public Shared Property IniKey_FilePath() As String
	Get
		Return clsIniRW.IniKey( mstrKey_FilePath )
	End Get
	Set( ByVal strValue As String )
		clsIniRW.IniKey( mstrKey_FilePath ) = strValue
	End Set
	End Property

	Public Shared Property IniKey_ImgFormRect() As System.Drawing.Rectangle
	Get
		Dim strRect		As String
		Dim rect		As System.Drawing.Rectangle
		Dim objConv		As New System.Drawing.RectangleConverter()

		strRect = clsIniRW.IniKey( mstrKey_ImgFormRect )
		'strRect="{X=506,Y=115,Width=600,Height=497}"
		'strRect="506,115,600,497"
		Try
			'rect = CType( _
			'		objConv.ConvertFrom( strRect ) , _ 
			'		System.Drawing.Rectangle  )
			rect = System.ComponentModel.TypeDescriptor.GetConverter( _ 
			GetType(System.Drawing.Rectangle)).ConvertFromString( strRect )
			'rect = strRect
		Catch e As System.Exception
			rect = new System.Drawing.Rectangle( _ 
					100,100, 200, 200 )
			
			System.Windows.Forms.MessageBox.Show( _
					e.ToString() )
		End Try
		objConv = Nothing

		Return rect
	End Get
	Set( ByVal rect As System.Drawing.Rectangle )
		clsIniRW.IniKey( mstrKey_ImgFormRect ) = _
				rect.X.ToString() & "," & _ 
				rect.Y.ToString() & "," & _ 
				rect.Width.ToString() & "," & _ 
				rect.Height.ToString()
	End Set
	End Property


	Public Shared Property IniKey_ImgTransparent() As boolean
	Get
		Dim strValue	As String
		Dim blRet		As boolean
		strValue = clsIniRW.IniKey( mstrKey_ImgTransparent )
		If strValue = "true" Then
			blRet = false
		Else
			blRet = true
		End If
		Return blRet
	End Get
	Set( ByVal blnValue As boolean )
		Dim strValue		As String
		If blnValue = true Then
			strValue = "false"
		Else
			strValue = "true"
		End If
		clsIniRW.IniKey( mstrKey_ImgTransparent ) = strValue
	End Set
	End Property



	Public Shared Property IniKey_Opacity() As Integer
	Get
		Dim strValue	As String
		Dim nRet		As Integer
		strValue = clsIniRW.IniKey( mstrKey_Opacity )
		Try
			nRet = System.Convert.ToDecimal( strValue )
		Catch e As System.Exception
			nRet = 0
		End Try
		Return nRet
	End Get
	Set( ByVal nValue As Integer )
		Dim strValue		As String
		strValue = nValue.ToString()
		clsIniRW.IniKey( mstrKey_Opacity ) = strValue
	End Set
	End Property


	Public Shared Property IniKey_Zoom() As Integer
	Get
		Dim strValue	As String
		Dim nRet		As Integer
		strValue = clsIniRW.IniKey( mstrKey_Zoom )
		Try
			nRet = System.Convert.ToDecimal( strValue )
		Catch e As System.Exception
			nRet = 100
		End Try
		Return nRet
	End Get
	Set( ByVal nValue As Integer )
		Dim strValue		As String
		strValue = nValue.ToString()
		clsIniRW.IniKey( mstrKey_Zoom ) = strValue
	End Set
	End Property



	Public Shared Property IniKey_ZoomMode() As clsIniRW.ZOOMMODE
	Get
		Dim strValue	As String
		Dim enmRet		As ZOOMMODE
		strValue = clsIniRW.IniKey( mstrKey_ZoomMode )
		If strValue = "nyanpen" Then
			enmRet = clsIniRW.ZOOMMODE.ZOOM_NYANPEN
		Else
			enmRet = clsIniRW.ZOOMMODE.ZOOM_MSPAINT
		End If
		Return enmRet
	End Get
	Set( ByVal nValue As ZOOMMODE )
		Dim strValue		As String
		
		If nValue = ZOOMMODE.ZOOM_NYANPEN Then
			strValue = "nyanpen"
		Else
			strValue = "mspaint"
		End If
		clsIniRW.IniKey( mstrKey_ZoomMode ) = strValue
	End Set
	End Property






	'BBBB߂ǂB
	Public Shared Sub Open()
		' http://cammy.co.jp/technical/2017/06/16/c-t@C̓ǂݏstreamreaderstreamwriter/
		mstrIniFileName = _
		System.Reflection.Assembly.GetExecutingAssembly().Location

		mstrIniFileName = System.IO.Path.ChangeExtension(mstrIniFileName, "ini")



		Try
			dim sr as System.IO.StreamReader
			sr = new System.IO.StreamReader( mstrIniFileName )

			mstrAllFileData = sr.ReadToEnd()
			sr.Close()
		catch e as System.Exception
			' t@CȂrbNĂB
			mstrAllFileData = ""

			Console.WriteLine( "߂ȂI File=h& mstrIniFileName )

		End Try


	End Sub


	Public Shared Sub Close()

		Try
			dim sr as System.IO.StreamWriter
			sr = new System.IO.StreamWriter( mstrIniFileName )

			sr.Write( mstrAllFileData )
			sr.Flush()
			sr.Close()
			sr.Dispose()
			sr = Nothing
		catch e as System.Exception
			' t@CȂrbNĂB
			
			Console.WriteLine( "ȂI File=h& mstrIniFileName )
			
		End Try


	End Sub





End Class



End NameSpace
